using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Controls;
using System.Windows.Documents;
using Infragistics.Olap.FlatData;

namespace StartupSolution.Views.PivotGrid
{
    /// <summary>
    /// Interaction logic for PivotGrid_FlatData.xaml
    /// </summary>
    public partial class PivotGrid_FlatData : Page
    {
        public PivotGrid_FlatData()
        {
            InitializeComponent();
            ((FlatDataSource)this.pivotGrid.DataSource).ItemsSource = BuildTransactions();
        }

        private List<Transaction> BuildTransactions()
        {
            int totalNames = 5;
            int totalQuarters = 1;

            List<Transaction> transactions = new List<Transaction>();

            List<TransactionType> transactionTypes = new List<TransactionType>();
            foreach (TransactionType transactionType in Enum.GetValues(typeof(TransactionType)).Cast<TransactionType>())
                transactionTypes.Add(transactionType);

            string drawdown;
            DateTime dt = DateTime.Now.Date;
            Random random = new Random();
            for (int i = 0; i < totalNames; i++)
            {
                drawdown = "Name " + i;
                foreach (TransactionType transactionType in transactionTypes)
                {
                    //if (random.NextDouble() < .4)
                    //    continue;

                    dt = DateTime.Now.Date;
                    for (int k = 0; k < totalQuarters; k++)
                    {
                        transactions.Add(new Transaction(
                            transactionType
                            , dt.ToString("yyyy/Q" + k)
                            , ((decimal)(random.NextDouble() * 10000000))
                            , "Name " + i
                            , false));

                        dt = dt.AddMonths(-3);
                    }
                }
            }

            transactions[0].IsDeleted = true;
            transactions[1].IsDeleted = true;
            transactions[2].IsDeleted = true;
            transactions[3].IsDeleted = true;

            return transactions;
        }
    }

    public enum TransactionType
    {
        TransactionType1,
        TransactionType2,
        TransactionType3,
        TransactionType4,
    }

    public class Transaction
    {
        public TransactionType TransactionType { get; set; }
        public string TransactionTypeName { get; set; }
        
        public string Quarter { get; set; }
        public decimal Amount { get; set; }

        public string Name { get; private set; }

        public bool IsDeleted { get; set; }

        public Transaction(TransactionType transactionType, string quarterName, decimal amount
            , string drawdownName, bool isDeleted)
        {
            this.IsDeleted = isDeleted;
            this.TransactionType = transactionType;
            this.TransactionTypeName = transactionType.ToString();
            this.Amount = amount;

            this.Quarter = quarterName;
            this.Name = drawdownName;
        }
    }
}
